//Vorteilung 1
//64-fache Genauigkeit:
//-45Grad bis +45Grad in Schritten von 4608 bis 1152.
//Auflsung: 0,01953125 Grad
//Datenblatt Seite 107: Modus 10: WGM 1010

#define SERVO_MITTE 6912
#define SERVO_MIN   4608
#define SERVO_MAX   9216
#define SERVO_HALB  2304
#define SERVO_DELTA_PHI_GRAD 0.01953125
#define SERVO_DELTA_PHI_RAD  0.00034088461953

//Bereich: -2304..+2304 bei hinzuzuzhlendem OFFSET==SERVO_MITTE von 6912

class Servo
{
    public:
        //Bewegungsalgorithmen mssen folgende Variablen aktualisieren,
        //um auch die Bewegung des Servos aufzeichnen zu knnen:
        uint32_t zeitmarke;
        uint32_t zeitmarke_alt;
        int      position;
        int      dauer;
        
        void start()
        {
            zeitmarke         = zeitgeber.zeitmarke;
            zeitmarke_alt     = zeitgeber.zeitmarke;

            position = SERVO_MITTE;
            dauer = EINE_SEKUNDE;

            ICR1 = 65535;

            TCCR1A = (1<<COM1A1) | (0<<COM1A0) | (1<<COM1B1) | (0<<COM1B0) | (0<<FOC1A) | (0<<FOC1B) | (1<<WGM11) | (0<<WGM10);
            TCCR1B = (0<<ICNC1) | (0<<ICES1) | (1<<WGM13) | (0<<WGM12) | (0<<CS12) | (0<<CS11) | (1<<CS10);
            DDRD |= (1<<PB5) | (1<<PB4); //auf Ausgang setzen.            

            OCR1A = SERVO_MITTE; //PWM-Breite setzen (entspricht fr Servo auf 0 Grad).
            OCR1B = SERVO_MITTE; //PWM-Breite setzen (entspricht fr Servo auf 0 Grad).
        }
};

Servo servo;
