class Zyklus
{
    private:
        uint8_t obergrenze;
        uint16_t zaehler;
        uint16_t max_zaehler;

    public:
        void start()
        {
            zaehler=0;
            max_zaehler=50;
            //CS02 CS01 CS00 000 ausgeschaltet
            //CS02 CS01 CS00 001 Vorteilung    1
            //CS02 CS01 CS00 010 Vorteilung    8
            //CS02 CS01 CS00 011 Vorteilung   64
            //CS02 CS01 CS00 100 Vorteilung  256
            //CS02 CS01 CS00 101 Vorteilung 1024 hier
            TCCR0 = (0<<FOC0) | (0<<WGM00) | (0<<COM01) | (0<<COM00) | (0<<WGM01) | (1<<CS02) | (0<<CS01) | (1<<CS00);
        }
        void stop()  //alle Register zurcksetzen, Timer und PWM ausschalten.
        {
            TCCR0 = (0<<FOC0) | (0<<WGM00) | (0<<COM01) | (0<<COM00) | (0<<WGM01) | (0<<CS02) | (0<<CS01) | (0<<CS00);
        }

        void setzeMaxZaehler(uint16_t maxwert=50) //Obergrenze, bei der der Zyklenzaehler wieder von vorn beginnt.
        {
            max_zaehler = maxwert;
            zaehler=0;
        }

        uint16_t holeZyklusZaehlstand()
        {
            return zaehler;
        }

        //Einstellbereich: 1ms bis maximal 28ms
        void warteBis_ms(uint8_t dauer_ms=20) //50Hz Zyklus entspricht warten bis 20ms vorbei
        {
            obergrenze = dauer_ms*9;
            zaehler++;
            zaehler%=max_zaehler;
            while(TCNT0<obergrenze);
            TCNT0=0;
            return;
        }
};

Zyklus zyklus;
