using namespace std;

class RS232
{
    public:
        HANDLE hCom;        
        RS232(long int baudrate)
        {
            comport = 1;
            this->baudrate = baudrate;
            datenbits = 8;
            stopbits = 1;
            
            init();   
        }
        
        string holeNachricht()
        {
            return nachricht;
        }
        
        void schreibeZeichen(int zeichen)
        {
            BOOL bWriteRC;
            static DWORD iBytesWritten;
            bWriteRC = WriteFile(hCom, &zeichen, 1, &iBytesWritten,NULL);
            return;
        }

        char leseZeichen()
        {
            char zeichen;
            BOOL bReadRC;
            static DWORD iBytesRead;
            bReadRC = ReadFile(hCom, &zeichen, 1, &iBytesRead, NULL);
            if (iBytesRead)
            {
                return zeichen;
            }
            else
            {
                return 0;         // return 0 if no character read
            }
        }        

        void beendeVerbindung()
        {
            CloseHandle(hCom);
        }
        
    private:
        string nachricht;
        int comport;
        long int baudrate;
        int datenbits;
        int stopbits;
        
        void init()
        {
            nachricht = "";
            
            if(!rs_initialise(comport ,baudrate, '8', 'N'))
            {
                nachricht.append("\nOpening Port Failed");
                delay_ms(5000);
                return;
            }            
        }   
        
        HANDLE rs_initialise (int io_port, const long int BaudRate, const char parity, const char data)
        {
            BOOL bPortReady;
            DCB dcb;
	        COMMTIMEOUTS CommTimeouts;

            char ComPortName[5]="COM ";
            ComPortName[3]='0'+ io_port;
            hCom = CreateFile(ComPortName, GENERIC_READ | GENERIC_WRITE,
                                          0,            // exclusive access
                                          NULL,         // no security
                                          OPEN_EXISTING,
                                          0,            // no overlapped I/O
                                          NULL);        // null template


            if ((int)hCom <= 0)
            {
                nachricht.append("\nserial port connect fail\n\r");
                return 0;
            }
            //else                nachricht.append("\n serial port COM%d connect OK \n\r", io_port);

            bPortReady = SetupComm(hCom, 128, 128); // set buffer sizes
            if (!bPortReady )
            {
                nachricht.append("\nserial port COM%d SetupComm fail  %d\n\r", io_port,  GetLastError());
                return 0;
            }
            //else                nachricht.append("\n serial port COM%d connect OK \n\r", io_port);

            bPortReady = GetCommState(hCom, &dcb);
            if (!bPortReady )
            {
                nachricht.append("\nserial port COM%d  GetCommState fail  %d\n\r", io_port,  GetLastError());
                return 0;
            }
            //  else                nachricht.append("\n serial port COM%d connect OK \n\r", io_port);
            dcb.BaudRate = BaudRate;
            if( data == '7') 
                dcb.ByteSize = 7;
            else             
                dcb.ByteSize = 8;
            if( parity == 'E') 
                dcb.Parity = EVENPARITY;
            if( parity == 'O') 
                dcb.Parity = ODDPARITY;
            else               
                dcb.Parity = NOPARITY;
            dcb.StopBits = ONESTOPBIT;
            dcb.fAbortOnError = TRUE;

            // set XON/XOFF
            dcb.fOutX = FALSE;                       // XON/XOFF off for transmit
            dcb.fInX = FALSE;                        // XON/XOFF off for receive
            // set RTSCTS
            dcb.fOutxCtsFlow = FALSE;               // turn off CTS flow control
            dcb.fRtsControl = FALSE;                // RTS_CONTROL_HANDSHAKE; //
            // set DSRDTR
            dcb.fOutxDsrFlow = FALSE;               // turn off DSR flow control
            //dcb.fDtrControl = DTR_CONTROL_ENABLE; // DTR handshake
            dcb.fDtrControl = DTR_CONTROL_DISABLE;  //
            // dcb.fDtrControl = DTR_CONTROL_HANDSHAKE; //

            bPortReady = SetCommState(hCom, &dcb);
            if (!bPortReady )
            {
                nachricht.append("\nserial port COM%d  SetCommState fail  %d\n\r", io_port,  GetLastError());
                return 0;
            }

            // Communication timeouts
            //COMMTIMEOUTS CommTimeouts;
            bPortReady = GetCommTimeouts (hCom, &CommTimeouts);
            CommTimeouts.ReadIntervalTimeout = 5 ;
            CommTimeouts.ReadTotalTimeoutConstant = 5 ;
            CommTimeouts.ReadTotalTimeoutMultiplier = 1 ;
            CommTimeouts.WriteTotalTimeoutConstant = 5 ;
            CommTimeouts.WriteTotalTimeoutMultiplier = 1 ;
            bPortReady = SetCommTimeouts (hCom, &CommTimeouts);
            if (!bPortReady )
            {
                nachricht.append("\nserial port COM%d SetCommTimeouts fail  %d\n\r", io_port,  GetLastError());
                return 0;
            }
            else
            {
                nachricht.append("\n serial port COM%d connect OK \n\r", io_port);
            }
            return (hCom);
        }

        void delay_ms(clock_t millis)
        {
           clock_t endtime;
           endtime = millis + clock();
           while( endtime > clock() );
        }
            
};
