import java.util.*;



class Evoopt
{
        public int generation_nr=0;

        private Random zufallszahl=null;

        public int ANZAHL_DNA=30;   //Anzahl der Individuen innerhalb einer Generation
        public int ANZAHL_BESTE=3;  //Anzahl der Besten einer Generation, die in die nchste Generation bernommen werden.
        public int MUTATIONSRATE=800; //0..1000

        private int PANZ=3;
                //hin amplitude*8  (0..255), z.B.100
                //hin geschwindigkeit (0..15), z.B.10, durch 16 teilen dann 0..255
                //her amplitude (0..255), z.B.100
                //pause (0..255), z.B. 100
         
        public double[] fehler = new double[ANZAHL_DNA];              //Merker fr die Fehler einer Generation
        private int[] bestindex = new int[ANZAHL_BESTE];           //Merker fr die Indices der ANZAHL_BESTE Besten einer Generation
        private double[] bestfehler = new double[ANZAHL_BESTE];        //Merker fr den Fehler bei den Besten.
//        private byte psatz[ANZAHL_DNA][PANZ];       //Merker der Parameterstze einer Generation
//        private byte psatzbest[ANZAHL_BESTE][PANZ]; //Merker der Parameterstze der Besten einer Generation

        public byte[][] psatz = new byte[ANZAHL_DNA][];       //Merker der Parameterstze einer Generation
        private byte[][] psatzbest = new byte[ANZAHL_BESTE][]; //Merker der Parameterstze der Besten einer Generation

        private LerneAufschwingen lerneaufschwingen=null;

        public Evoopt(LerneAufschwingen lerneaufschwingen)
        {
            zufallszahl = new Random(0);
            this.lerneaufschwingen = lerneaufschwingen;
            
            for(int i=0;i<ANZAHL_DNA;i++)
                psatz[i] = new byte[PANZ];
            for(int i=0;i<ANZAHL_BESTE;i++)
                psatzbest[i] = new byte[PANZ];
        }

        int zufall(int von, int bis)
        {            
            return zufallszahl.nextInt(bis-von+1)+von;        
        }

        void mutieren(byte[] p) //nur Bit0..7
        {
            if(zufall(0,1000)>MUTATIONSRATE)              //Hier Mutationsniveau einstellen
                return; 
     
            int index = zufall(0,PANZ-1);  //Auswahl eines der Parameter
            int stelle = zufall(0,8);    

            if( (p[index] & (1<<stelle)) > 0)
            {
                p[index] = (byte)(p[index] & ~(1<<stelle));
            }     
            else
            {
                p[index] = (byte)(p[index] | (1<<stelle));
            }
        }

        void rekombinieren(byte[] best1, byte[] best2, byte[] satz)
        {
            for(int k=0;k<PANZ;k++)
            {     
                satz[k]=0;        
                for(int i=0;i<16;i++)
                {                   
                    if(zufall(0,100)>50)
                    {
                        satz[k] |= (best1[k] & (1<<i));
                    }
                    else
                    {
                        satz[k] |= (best2[k] & (1<<i));                           
                    }            
                }     
            }    
        }

        void kontrollausgabe()
        {
                //Vorbereitung der Kontrollausgabe
                //Kontrollausgabe
                System.out.println("Kleinster Fehler = "+bestfehler[0]+"\n");
                for(int k=0;k<PANZ;k++)
                    System.out.println("Param Nr."+k+" = "+(int)lerneaufschwingen.param[k]+"\n");                    
        }

        void erzeugeNeueGeneration()
        {
            //1. Fehler bei allen Parameterstzen bestimmen
            if(generation_nr==0)
            {
                for(int i=0;i<ANZAHL_DNA;i++)
                {
                    for(int k=0;k<PANZ;k++)            
                        psatz[i][k] = lerneaufschwingen.param[k];
        
                    mutieren(psatz[i]);
        
                    //Fehler-Array wird von Thread generiert!
                    //fehler[i] = lerneaufschwingen.berechneFehler(psatz[i]);
                }
            }
            else
            {
            //Mehrere Generationen durchrechnen.
                //ANZAHL_BESTE Beste finden:
                for(int i=0;i<ANZAHL_BESTE;i++)
                {
                    bestfehler[i] = fehler[0];
                    bestindex[i] = 0;
                }    
                for(int i=0;i<ANZAHL_DNA;i++)
                {
                    if( (fehler[i]<=bestfehler[0] && fehler[i]>0.0)
                       || bestfehler[0]<0.0
                    )
                    {
                        for(int p=ANZAHL_BESTE-1;p>=1;p--)
                        {
                            bestfehler[p] = bestfehler[p-1];
                            bestindex[p] = bestindex[p-1];
                        }                               
                        bestfehler[0]=fehler[i];
                        bestindex[0]=i;                
                    }            
                }                     

                kontrollausgabe();
    
                //2. Beste merken
                for(int i=0;i<ANZAHL_BESTE;i++)
                    for(int k=0;k<PANZ;k++)            
                        psatzbest[i][k] = psatz[bestindex[i]][k];            

                //3. rekombinieren
                for(int i=ANZAHL_BESTE;i<ANZAHL_DNA;i++)
                {
                    rekombinieren(psatzbest[zufall(0,ANZAHL_BESTE-1)],psatzbest[zufall(0,ANZAHL_BESTE-1)],psatz[i]);
                    if(zufall(0,999)<MUTATIONSRATE)
                        mutieren(psatz[i]);            
                }    

                //4. Beste zurckschreiben
                for(int i=0;i<ANZAHL_BESTE;i++)
                {
                    for(int k=0;k<PANZ;k++)            
                        psatz[i][k]=psatzbest[i][k];            
                }
               //5. Fehler bei allen Parameterstzen bestimmen
               //GESCHIEHT AUSSERHALB
               // for(int i=0;i<ANZAHL_DNA;i++)
               //     fehler[i] =  lerneaufschwingen.berechneFehler(psatz[i]);
                
            }                
            generation_nr++;                
        } //erzeugeNeueGeneration() 
        
        public void zeigePSATZ()
        {
            for(int i=0;i<psatz.length;i++)
            {
                for(int k=0;k<psatz[i].length;k++)
                    System.out.print((128+(int)psatz[i][k])+" ");
                System.out.println();                    
            }
        }  
}

