import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

public class LerneAufschwingen extends Applet implements Runnable
{
    public Evoopt evoopt;

    //Datenhaltung der Optimierungsparameter fr das Aufschwingen:
    public byte[] param = {100-128,100-128,100-128}; //amp, geschw, amp2, pause.  geschw. wird durch 20 geteilt benutzt!
    public double GUETE=0.0;

    public Button knopf;
    public TextArea textbereich;
    public TextArea kontroll_textbereich;

    public int modus=0;
    public long zeit_aktuell;
             
    public Thread thread;             

    double berechneFehler(byte[] par)
    {
        //aus den param[] Parameter fr Aufschwingen bilden, Test durchfhren, 1/(Gte+1) als Fehler zurckgeben,
        //bzw. vorher einfach in Attribut GUETE Ergebnis speichern und ausgeben:
        return 1.0/( (double)GUETE + 1.0 );
    }
                    
    public void init()
    {
        evoopt = new Evoopt(this);
    
        setLayout(null);
    
        knopf = new Button("Exit");
            
        add(knopf);   
        knopf.addActionListener(new Listener("java Modewahl"));         
        knopf.setLocation(0,10);
        knopf.setSize(190,20);
        
        textbereich = new TextArea("Empfangene Zeilen von Mikrocontroller",8,50,TextArea.SCROLLBARS_BOTH);
        kontroll_textbereich = new TextArea("Ergebnisse",8,50,TextArea.SCROLLBARS_BOTH);
        add(textbereich);
        add(kontroll_textbereich);
        textbereich.setLocation(5,30);        
        textbereich.setSize(400,400);
        kontroll_textbereich.setBounds(405,30,400,400);        
        kontroll_textbereich.setSize(400,400);        
        
        thread = new Thread(this);
        thread.start();
    }
    
    public void setzeKontrolltext(String text)
    {
        kontroll_textbereich.setText(
                                        kontroll_textbereich.getText()+"\n"+text
                                    );
    }

    public void setzeErgebnistext(String text)
    {
                textbereich.setText(
                                        textbereich.getText()+"\n"+text
                                    );
    }
    
    public void run()
    {
        RS232 rs232=null;
        String befehl=null;
        try
        {
            rs232= new RS232();
        }
        catch ( Exception e )
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }        
        if(rs232!=null)
        {
          int nr=0;
          
          //Ausgabe in Ergebnis-Fenster:
          //Tabellen Spalten Legende:
          //Generation par0 par1 par2 par3 Fehler
          setzeErgebnistext("\nGeneration par0 par1 par2 par3 Fehler\n");

          while(true)
          {
           //Generiere neue Generation von Parameterstzen:
           evoopt.erzeugeNeueGeneration();

           System.out.println("Parametergeneration Nr."+evoopt.generation_nr+" gebildet.");
           evoopt.zeigePSATZ();
                    
           for(int iii=0;iii<evoopt.ANZAHL_DNA;iii++)
           {
            //bernehme den aktuellen Parametersatz aus evoopt:
            int auf_hin_amplitude       = 128+(int)evoopt.psatz[iii][0];
            int auf_hin_geschwindigkeit = 128+(int)evoopt.psatz[iii][1]; //Um Wertebereich 0..255 zu haben
            int auf_her_amplitude       = 128+(int)evoopt.psatz[iii][2];
                       
            //Neuen Parametersatz testen:        
            
            //Ein Durchlauf bentigt die Abarbeitung mehrerer Befehle:
            boolean durchlauf_fertig = false;
            
            while(durchlauf_fertig==false)
            {
            String text = "";
            while(true)
            {
                String neutext = rs232.lesen();
                if(neutext!=null)
                    text+=neutext;
                //Nach Befehl suchen:
                befehl=null;
                int i=0;
                boolean gefunden=false;
                if(text.length()>4)
                {
                    for(i=text.length()-4;i>=0;i--)
                        if(text.substring(i,i+4).equals("CODE"))
                        {
                            gefunden=true;
                            break;
                        }                            
                    int k=0;                        
                    if(gefunden==true)
                    {
                        gefunden=false;
                        for(k=i;k<text.length();k++)
                            if(text.substring(k,k+1).equals("#"))
                            {
                                gefunden=true;
                                break;
                            }
                        if(gefunden==true)
                        {
                            befehl = text.substring(i,k);
                        }
                    }
                }
                if(befehl!=null)
                    break;                                           
            }                
            
            setzeKontrolltext("Befehl empfangen:"+befehl);
            nr = (int)Double.parseDouble(befehl.substring(4,7));
            String befehl_senden = "";
            switch(nr)
            {
                case 0:
                    befehl_senden = "1#";
                    rs232.schreiben(befehl_senden);
                    setzeKontrolltext("Befehl geschickt:"+befehl_senden);
                break;
                case 10:  //hin amplitude*8  (0..255), z.B.100
                    befehl_senden = ""+auf_hin_amplitude+"#";
                    rs232.schreiben(befehl_senden);
                    setzeKontrolltext("Befehl geschickt:"+befehl_senden);
                break;
                case 11:  //hin geschwindigkeit (0..15), z.B.10
                    befehl_senden = ""+auf_hin_geschwindigkeit+"#";
                    rs232.schreiben(befehl_senden);
                    setzeKontrolltext("Befehl geschickt:"+befehl_senden);
                break;
                case 12: //her amplitude (0..255), z.B.100
                    befehl_senden = ""+auf_her_amplitude+"#";
                    rs232.schreiben(befehl_senden);
                    setzeKontrolltext("Befehl geschickt:"+befehl_senden);
                break;
                case 100: //Gte extrahieren und in richtigem Fehler-Array-Element merken:
                    int kk=0;
                    boolean gefunden = false;
                    for(kk=0;kk<befehl.length()-6;kk++)
                    {
                        if(befehl.substring(kk,kk+6).equals("GUETE="))
                        {
                            gefunden = true;
                            break;
                        }                            
                    }
                    if(gefunden==true)
                    {
                        evoopt.fehler[iii]=1.0/( 1.0 + Math.abs( Double.parseDouble(befehl.substring(kk+6,befehl.length())))  );
                        durchlauf_fertig = true;
                        
//                        setzeErgebnistext("\nGeneration par0 par1 par2 par3 Fehler\n");
                        setzeErgebnistext(
                                             ""+
                                             evoopt.generation_nr+" "+
                                             auf_hin_amplitude+" "+
                                             auf_hin_geschwindigkeit+" "+
                                             auf_her_amplitude+" "+
                                             evoopt.fehler[iii]
                                          );
                    }
                break;
                default:
                break;
            }//switch                    
            }//while(durchlauf_fertig==false)
           }//for i 0..evoopt.ANZAHL_DNA-1  
          }//while(true)            
        }//if(rs232!=null)    
    }


    public void paint(Graphics g)
    {    
        g.setColor(new Color(200,255,200));
        g.fillRect(5,5,200,100);
    }

    public class Listener implements ActionListener
    {
        String befehl;

        Listener(String befehl)
        {
            this.befehl = befehl;
        }
        
        public void actionPerformed(ActionEvent e)
        {
            //Externes Programm ausfhren und das aktuelle Programm beenden.
            try
            {            
                Runtime.getRuntime().exec(befehl);
            }
            catch(Exception ee)
            {
            }                
            System.exit(0);
        }
    }

    public static void main(String[] args)
    {
        LerneAufschwingen mw = new LerneAufschwingen();
        mw.init();
        mw.start();
        mw.repaint();

        JFrame mF = new JFrame("Lerne Aufschwingen: ber genetischen Algorithmus Parameter finden");
        mF.getContentPane().add(mw);
        mF.pack();
        mF.setSize(1000,700);
        mF.setLocation(2,2);
        mF.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        mF.setVisible(true);
    }
}

