import gnu.io.CommPort;
import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;

import java.io.FileDescriptor;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class RS232
{
    public InputStream in;
    public OutputStream out;

    public RS232()
    {
        super();
        try
        {
            connect();
        }
        catch(Exception e)
        {
            System.out.println(e);
            System.out.println("ERROR Konte nicht verbinden.");
            System.exit(0);
        }            
    }
    
    void connect() throws Exception
    {
        String portName = "COM1";
    
        CommPortIdentifier portIdentifier = CommPortIdentifier.getPortIdentifier(portName);
        if ( portIdentifier.isCurrentlyOwned() )
        {
            System.out.println("Error: Port is currently in use");
        }
        else
        {
            CommPort commPort = portIdentifier.open(this.getClass().getName(),2000);
            
            if ( commPort instanceof SerialPort )
            {
                SerialPort serialPort = (SerialPort) commPort;
                serialPort.setSerialPortParams(115200,SerialPort.DATABITS_8,SerialPort.STOPBITS_1,SerialPort.PARITY_NONE);
                
                in = serialPort.getInputStream();
                out = serialPort.getOutputStream();
            }
            else
            {
                System.out.println("Error: Only serial ports are handled by this example.");
            }
        }     
    }
    
    public String lesen()
    {
      try
      {
        byte[] buffer = new byte[1024];

        int laenge = this.in.read(buffer);
        if(laenge>0)
        {
            String text = new String(buffer,0,laenge);
//            System.out.println(text);
            return text;
        }            
        else
            return null;
      }
      catch(Exception e)
      {
//        System.out.println(e);
//        System.out.println("ERROR Konte nichts lesen.");
        return null;
      }            
    }

    public void schreiben(String text)
    {
      try
      {
        for(int i=0;i<text.length();i++)
            this.out.write(text.charAt(i));
      }
      catch(Exception e)
      {
//        System.out.println(e);
//        System.out.println("ERROR Konte nichts schreiben.");
        return;
      }            
    }

    
    public static void main ( String[] args )
    {
        RS232 rs232=null;
        String befehl=null;
        try
        {
            rs232= new RS232();
        }
        catch ( Exception e )
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }        
        if(rs232!=null)
        {
          int nr=0;
          while(true)
          {
            String text = "";
        
            while(true)
            {
                String neutext = rs232.lesen();
                if(neutext!=null)
                    text+=neutext;
                //Nach Befehl suchen:
                befehl=null;
                int i=0;
                boolean gefunden=false;
                if(text.length()>4)
                {
                    for(i=text.length()-4;i>=0;i--)
                        if(text.substring(i,i+4).equals("CODE"))
                        {
                            gefunden=true;
                            break;
                        }                            
                    int k=0;                        
                    if(gefunden==true)
                    {
                        gefunden=false;
                        for(k=i;k<text.length();k++)
                            if(text.substring(k,k+1).equals("#"))
                            {
                                gefunden=true;
                                break;
                            }
                        if(gefunden==true)
                        {
                            befehl = text.substring(i,k);
                        }
                    }
                }
                if(befehl!=null)
                    break;                                           
            }                
            
            System.out.println("Befehl empfangen:"+befehl);
            nr = (int)Double.parseDouble(befehl.substring(4,7));
            String befehl_senden = "";
            switch(nr)
            {
                case 0:
                    befehl_senden = "1#";
                    rs232.schreiben(befehl_senden);
                    System.out.println("Befehl geschickt:"+befehl_senden);
                break;
                case 10:  //hin amplitude*8  (0..255), z.B.100
                    befehl_senden = "100#";
                    rs232.schreiben(befehl_senden);
                    System.out.println("Befehl geschickt:"+befehl_senden);
                break;
                case 11:  //hin geschwindigkeit (0..15), z.B.10
                    befehl_senden = "10#";
                    rs232.schreiben(befehl_senden);
                    System.out.println("Befehl geschickt:"+befehl_senden);
                break;
                case 12: //her amplitude (0..255), z.B.100
                    befehl_senden = "100#";
                    rs232.schreiben(befehl_senden);
                    System.out.println("Befehl geschickt:"+befehl_senden);
                break;
                case 13: //pause (0..255), z.B. 100
                    befehl_senden = "100#";
                    rs232.schreiben(befehl_senden);
                    System.out.println("Befehl geschickt:"+befehl_senden);
                break;
                default:
                break;
            }                    
          }//while(true)            
        }//if(rs232!=null)
    }//main
}//class RS232