import gnu.io.CommPort;
import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;

import java.io.FileDescriptor;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import java.awt.*;

public class TwoWaySerialComm
{
    public static SerialWriter writer=null;

    public static String senden;
    public static StringBuffer empfangen;

//Textbereich hier registrierbar machen:
    public static TextArea textbereich = null; 

    public static double[] parameter = null;
    public static double parameter_alt = 0.0;

    public static void registriereTextbereich(TextArea text)
    {
        textbereich = text;
    }

    public static void registriereParameter(double[] par)
    {
        parameter = par;
        parameter_alt = par[0];
    }

    
    //Zu sendendes String hiermit bergeben.
    //wird geleert, wenn Senden komplett ist.
    public boolean senden(String text)
    {
        if(senden.equals(""))
        {
            senden = text;
            return true;
        }    
        else
        {
            return false; //bergebener Text kann gerade nicht gesendet werden.            
        }
    
    }

    public TwoWaySerialComm()
    {
        super();
    }
    
    void connect ( String portName ) throws Exception
    {
        senden = "";
        empfangen = new StringBuffer();
    
        CommPortIdentifier portIdentifier = CommPortIdentifier.getPortIdentifier(portName);
        if ( portIdentifier.isCurrentlyOwned() )
        {
            System.out.println("Error: Port is currently in use");
        }
        else
        {
            CommPort commPort = portIdentifier.open(this.getClass().getName(),2000);
            
            if ( commPort instanceof SerialPort )
            {
                SerialPort serialPort = (SerialPort) commPort;
                serialPort.setSerialPortParams(115200,SerialPort.DATABITS_8,SerialPort.STOPBITS_1,SerialPort.PARITY_NONE);
                
                InputStream in = serialPort.getInputStream();
                OutputStream out = serialPort.getOutputStream();

                             
                (new Thread(new SerialReader(in))).start();
                
                writer = new SerialWriter(out);
                (new Thread(writer)).start();

            }
            else
            {
                System.out.println("Error: Only serial ports are handled by this example.");
            }
        }     
    }
    
    /** */
    public static class SerialReader implements Runnable 
    {
        InputStream in;
        
        public SerialReader ( InputStream in )
        {
            this.in = in;
        }
        
        public void run ()
        {
            byte[] buffer = new byte[1024];
            int len = -1;
            try
            {
                while ( ( len = this.in.read(buffer)) > -1 )
                {
                    if(textbereich!=null)
                    {
                        String text = textbereich.getText();
                        textbereich.setText(text+(new String(buffer,0,len)));
                    }
//                    System.out.print(new String(buffer,0,len));
                }
            }
            catch ( IOException e )
            {
                e.printStackTrace();
            }            
        }
    }

    /** */
    public static class SerialWriter implements Runnable 
    {
        OutputStream out;
        
        public SerialWriter ( OutputStream out )
        {
            this.out = out;
        }
        
        public void run ()
        {
if(parameter!=null)
{
    System.out.println("Parameter0:"+parameter[0]+" alter Wert:"+parameter_alt);
}        
            try
            {             
                if(parameter!=null && parameter[0]!=parameter_alt)   
                {
                    int wert = (int)Math.round((parameter[0]*2304.0)/45.0);
                    
                    if(parameter[0]<90.0)  //100.0 als Abbruchwert verwenden
                    {
                        if(wert>2304)
                            wert = 2304;
                        if(wert<-2304)
                            wert = -2304;                                                    
                    
                        senden = ""+wert;
                        byte[] puffer = senden.getBytes();
                        for(int i=0;i<puffer.length;i++)
                            this.out.write((int)puffer[i]);
                        //String leeren, damit klar ist, dass wieder etwas gesendet werden knnte:
                        senden="";    
                        parameter_alt = parameter[0];
                    }
                }
                else if(senden!=null && !senden.equals(""))   
                {
System.out.println("Sende ber RS232 "+senden+"");                
                    byte[] puffer = senden.getBytes();
                    for(int i=0;i<puffer.length;i++)
                        this.out.write((int)puffer[i]);
                    //String leeren, damit klar ist, dass wieder etwas gesendet werden knnte:
                    senden="";    
                }
            }
            catch ( IOException e )
            {
                e.printStackTrace();
            }            
        }
    }    
}